Attribute VB_Name = "mdAPI"
Option Explicit

Public Const LOCALE_SSHORTDATE = &H1F
Public Const LOCALE_SLONGDATE = &H20
Public Const LOCALE_STIME = &H1E
Public Const LOCALE_STIMEFORMAT = &H1003

Private Const LOCALE_USER_DEFAULT = &H400
Private Const MAX_BUFFER_SIZE = 100

Public Const LOCALE_SABBREVMONTHNAME1 = &H44
Public Const LOCALE_SMONTHNAME1 = &H38
Public Const LOCALE_SABBREVDAYNAME1 = &H31

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function CreateRoundRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Public Declare Function FrameRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long, ByVal hBrush As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function FillRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long, ByVal hBrush As Long) As Long
Public Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long

Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function GetForegroundWindow Lib "user32" () As Long

Private Declare Function GetSystemDefaultLCID Lib "kernel32" () As Long
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long) As Long

'Public Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = (-4)

Private Const GWL_EXSTYLE = -20
 
Private Const WS_EX_TOOLWINDOW As Long = &H80&

Public Sub SetWindowsStyle(lHwnd As Long)

    Dim lStyle As Long
    lStyle = GetWindowLong(lHwnd, GWL_EXSTYLE)
    lStyle = lStyle Or WS_EX_TOOLWINDOW
    SetWindowLong lHwnd, GWL_EXSTYLE, lStyle
    
    SetParent lHwnd, 0
    
End Sub

Public Function fnGetDateFormat(lTipFormata As Long) As String

    Dim lAPIRtn As Long, lngLocale  As Long
    Dim lBufferSize As Long
    Dim psOriginalSDateFormat As String

    psOriginalSDateFormat = String$(MAX_BUFFER_SIZE, 0)
    lBufferSize = MAX_BUFFER_SIZE - 1

    lngLocale = GetSystemDefaultLCID()

    'Obtain Short Date Format
    '------------------------
    lAPIRtn = GetLocaleInfo(LOCALE_USER_DEFAULT, lTipFormata, psOriginalSDateFormat, lBufferSize)
    
    If lAPIRtn > 0 Then
        fnGetDateFormat = Left$(psOriginalSDateFormat, lAPIRtn - 1)
    Else
        fnGetDateFormat = ""
    End If

End Function

Public Function GetMonthName(lMonth As Long)

    Dim Buffer As String, Ret As String, GetInfo As String
    
    Buffer = String$(256, 0)
    Ret = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SMONTHNAME1 + lMonth - 1, Buffer, Len(Buffer))
    If Ret > 0 Then
        GetInfo = Left$(Buffer, Ret - 1)
    Else
        GetInfo = ""
    End If
    GetMonthName = GetInfo

End Function

Public Function GetDayName(lDay As Long)

    Dim Buffer As String, Ret As String, GetInfo As String
    Buffer = String$(256, 0)
    Ret = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SABBREVDAYNAME1 + lDay - 1, Buffer, Len(Buffer))
    If Ret > 0 Then
        GetInfo = Left$(Buffer, Ret - 1)
    Else
        GetInfo = ""
    End If
    GetDayName = GetInfo

End Function

